Index: src/sas/sasgui/guiframe/aboutbox.py
===================================================================
--- src/sas/sasgui/guiframe/aboutbox.py	(revision b963b2066d6a76fe5073000c5a596a6fd0130ac4)
+++ src/sas/sasgui/guiframe/aboutbox.py	(revision 1b4cb415644d6a02d2bc0e559654a42560242058)
@@ -108,4 +108,5 @@
         self.bitmap_button_tudelft = wx.BitmapButton(self, -1, wx.NullBitmap)
         self.bitmap_button_dls = wx.BitmapButton(self, -1, wx.NullBitmap)
+        self.bitmap_button_bam = wx.BitmapButton(self, -1, wx.NullBitmap)
 
         self.static_line_3 = wx.StaticLine(self, -1)
@@ -128,4 +129,5 @@
         self.Bind(wx.EVT_BUTTON, self.onTudelftLogo, self.bitmap_button_tudelft)
         self.Bind(wx.EVT_BUTTON, self.onDlsLogo, self.bitmap_button_dls)
+        self.Bind(wx.EVT_BUTTON, self.onBamLogo, self.bitmap_button_bam)
         # end wxGlade
         # fill in acknowledgements
@@ -226,4 +228,10 @@
         logo = wx.Bitmap(image)
         self.bitmap_button_dls.SetBitmapLabel(logo)
+
+        image = file_dir + "/images/bam_logo.png"
+        if os.path.isfile(config._bam_logo):
+            image = config._bam_logo
+        logo = wx.Bitmap(image)
+        self.bitmap_button_bam.SetBitmapLabel(logo)
 
         # resize dialog window to fit version number nicely
@@ -258,4 +266,5 @@
         self.bitmap_button_tudelft.SetSize(self.bitmap_button_tudelft.GetBestSize())
         self.bitmap_button_dls.SetSize(self.bitmap_button_dls.GetBestSize())
+        self.bitmap_button_bam.SetSize(self.bitmap_button_bam.GetBestSize())
         # end wxGlade
 
@@ -325,4 +334,6 @@
         sizer_logos.Add(self.bitmap_button_dls, 0,
                         wx.LEFT|wx.ADJUST_MINSIZE, 2)
+        sizer_logos.Add(self.bitmap_button_bam, 0,
+                        wx.LEFT|wx.ADJUST_MINSIZE, 2)
 
         sizer_logos.Add((10, 50), 0, wx.ADJUST_MINSIZE, 0)
@@ -430,4 +441,11 @@
         event.Skip()
 
+    def onBamLogo(self, event):
+        """
+        """
+        # wxGlade: DialogAbout.<event_handler>
+        launchBrowser(config._bam_url)
+        event.Skip()
+
 # end of class DialogAbout
 
Index: src/sas/sasgui/guiframe/config.py
===================================================================
--- src/sas/sasgui/guiframe/config.py	(revision 8ac05a59a0078f40fc8af4febae16624b9d5c818)
+++ src/sas/sasgui/guiframe/config.py	(revision 1b4cb415644d6a02d2bc0e559654a42560242058)
@@ -51,5 +51,5 @@
 '''M. Doucet et al. SasView Version 4.1.2, Zenodo, 10.5281/zenodo.825675'''
 _acknowledgement =  \
-'''This work was originally developed as part of the DANSE project funded by the US NSF under Award DMR-0520547,\n but is currently maintained by a collaboration between UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, DLS, and the scattering community.\n\n SasView also contains code developed with funding from the EU Horizon 2020 programme under the SINE2020 project (Grant No 654000).\nA list of individual contributors can be found at: http://www.sasview.org/contact.html
+'''This work was originally developed as part of the DANSE project funded by the US NSF under Award DMR-0520547,\n but is currently maintained by a collaboration between UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, DLS, BAM and the scattering community.\n\n SasView also contains code developed with funding from the EU Horizon 2020 programme under the SINE2020 project (Grant No 654000).\nA list of individual contributors can be found at: http://www.sasview.org/contact.html
 '''
 
@@ -90,9 +90,10 @@
 _tudelft_url = "http://www.tnw.tudelft.nl/en/cooperation/facilities/reactor-instituut-delft/"
 _dls_url = "http://www.diamond.ac.uk/"
+_bam_url = "http://www.bam.de/"
 _danse_url = "http://www.cacr.caltech.edu/projects/danse/release/index.html"
 _inst_url = "http://www.utk.edu"
 _corner_image = os.path.join(icon_path, "angles_flat.png")
 _welcome_image = os.path.join(icon_path, "SVwelcome.png")
-_copyright = "(c) 2009 - 2018, UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, and DLS"
+_copyright = "(c) 2009 - 2018, UTK, UMD, NIST, ORNL, ISIS, ESS, ILL, ANSTO, TU Delft, DLS and BAM"
 marketplace_url = "http://marketplace.sasview.org/"
 