Index: DataLoader/docs/sphinx/api/index.rst
===================================================================
--- DataLoader/docs/sphinx/api/index.rst	(revision 0997158f0d11874fd896ee66b3bb468898c9bb2b)
+++ DataLoader/docs/sphinx/api/index.rst	(revision 480ddb484a6d29f6d3a29474d2cfd2f302efe0c7)
@@ -15,4 +15,5 @@
 
    data_info.rst
+   loader.rst
    manipulations.rst
    qsmearing.rst
Index: DataLoader/docs/sphinx/api/loader.rst
===================================================================
--- DataLoader/docs/sphinx/api/loader.rst	(revision 480ddb484a6d29f6d3a29474d2cfd2f302efe0c7)
+++ DataLoader/docs/sphinx/api/loader.rst	(revision 480ddb484a6d29f6d3a29474d2cfd2f302efe0c7)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+loader
+******************************************************************************
+
+:mod:`DataLoader.loader`
+==============================================================================
+
+.. automodule:: DataLoader.loader
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: DataLoader/docs/sphinx/api/readers/danse_reader.rst
===================================================================
--- DataLoader/docs/sphinx/api/readers/danse_reader.rst	(revision 480ddb484a6d29f6d3a29474d2cfd2f302efe0c7)
+++ DataLoader/docs/sphinx/api/readers/danse_reader.rst	(revision 480ddb484a6d29f6d3a29474d2cfd2f302efe0c7)
@@ -0,0 +1,15 @@
+.. Autogenerated by genmods.py
+
+******************************************************************************
+danse_reader
+******************************************************************************
+
+:mod:`DataLoader.readers.danse_reader`
+==============================================================================
+
+.. automodule:: DataLoader.readers.danse_reader
+   :members:
+   :undoc-members:
+   :inherited-members:
+   :show-inheritance:
+
Index: DataLoader/docs/sphinx/api/readers/index.rst
===================================================================
--- DataLoader/docs/sphinx/api/readers/index.rst	(revision 0997158f0d11874fd896ee66b3bb468898c9bb2b)
+++ DataLoader/docs/sphinx/api/readers/index.rst	(revision 480ddb484a6d29f6d3a29474d2cfd2f302efe0c7)
@@ -18,4 +18,5 @@
    associations.rst
    cansas_reader.rst
+   danse_reader.rst
    hfir1d_reader.rst
    IgorReader.rst
Index: DataLoader/docs/sphinx/conf.py
===================================================================
--- DataLoader/docs/sphinx/conf.py	(revision 0997158f0d11874fd896ee66b3bb468898c9bb2b)
+++ DataLoader/docs/sphinx/conf.py	(revision 480ddb484a6d29f6d3a29474d2cfd2f302efe0c7)
@@ -12,11 +12,13 @@
 # serve to show the default.
 
-import sys, os
+import sys, os, glob
 
 # If extensions (or modules to document with autodoc) are in another directory,
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
-sys.path.append(os.path.abspath(os.path.dirname('../../DataLoader')))
-sys.path.append(os.path.abspath(os.path.dirname('../../DataLoader/readers')))
+
+path = glob.glob('../../build/lib.*')[0]
+sys.path.append(path)
+
 sys.path.append(os.path.abspath('_extensions'))
 # -- General configuration -----------------------------------------------------
Index: DataLoader/docs/sphinx/genmods.py
===================================================================
--- DataLoader/docs/sphinx/genmods.py	(revision 0997158f0d11874fd896ee66b3bb468898c9bb2b)
+++ DataLoader/docs/sphinx/genmods.py	(revision 480ddb484a6d29f6d3a29474d2cfd2f302efe0c7)
@@ -51,29 +51,28 @@
         f.write(INDEX_TEMPLATE%locals())
 
+modules = []
+path = os.path.abspath(os.path.dirname('../../'))
 
-modules=[
-    ('data_info', 'data_info'),
-    ('loader', 'loader'),
-    ('manipulations', 'manipulations'),
-    ('qsmearing', 'qsmearing'),
-    ('smearing_2d', 'smearing_2d'),
-]
+
+list = os.listdir(path)
+for item in list:
+    toks = os.path.splitext(os.path.basename(item))
+    if toks[1]=='.py' and toks[0] not in ["__init__", "setup"]:
+        exec "module = ('%s', '%s')"%(toks[0], toks[0])
+        modules.append(module)
+
 package='DataLoader'
 package_name='Reference'
-#genfiles(package, package_name, modules)
 
 if __name__ == "__main__":
     genfiles(package, package_name, modules, dir='api')
-    
-    modules=[
-    ('abs_reader', 'abs_reader'),
-    ('ascii_reader', 'ascii_reader'),
-    ('associations', 'associations'),
-    ('cansas_reader', 'cansas_reader'),
-    ('hfir1d_reader', 'hfir1d_reader'),
-    ('IgorReader', 'IgorReader'),
-    ('red2d_reader', 'red2d_reader'),
-    ('tiff_reader', 'tiff_reader'),
-    ]
+    modules = []
+    path = os.path.abspath(os.path.dirname('../../readers/'))
+    list = os.listdir(path)
+    for item in list:
+        toks = os.path.splitext(os.path.basename(item))
+        if toks[1]=='.py' and toks[0] not in ["__init__", "setup"]:
+         exec "module = ('%s', '%s')"%(toks[0], toks[0])
+         modules.append(module)
     package='DataLoader.readers'
     package_name='Readers'
Index: DataLoader/loader.py
===================================================================
--- DataLoader/loader.py	(revision 0997158f0d11874fd896ee66b3bb468898c9bb2b)
+++ DataLoader/loader.py	(revision 480ddb484a6d29f6d3a29474d2cfd2f302efe0c7)
@@ -76,7 +76,8 @@
             return super(Registry, self).load(path, format=format)
         except:
+            raise
             # No reader was found. Default to the ascii reader.
-            ascii_loader = ascii_reader.Reader()
-            return ascii_loader.read(path)
+            #ascii_loader = ascii_reader.Reader()
+            #return ascii_loader.read(path)
         
     def find_plugins(self, dir):