Index: src/sas/perspectives/invariant/media/invariant_help.rst
===================================================================
--- src/sas/perspectives/invariant/media/invariant_help.rst	(revision ec392464eef959a5c2e87e6a72ed72fd7e947a07)
+++ src/sas/perspectives/invariant/media/invariant_help.rst	(revision 0721c3d85f20ae9870555f28be91862c7bc82ce5)
@@ -3,4 +3,10 @@
 .. This is a port of the original SasView html help file to ReSTructured text
 .. by S King, ISIS, during SasView CodeCamp-III in Feb 2015.
+
+.. |Ang| unicode:: U+212B
+.. |pi| unicode:: U+03C0
+.. |bigdelta| unicode:: U+0394
+.. |rho| unicode:: U+03C1
+.. |phi| unicode:: U+03C6
 
 Invariant Calculation Perspective
@@ -9,13 +15,11 @@
 Scattering_Invariant_
 
+How_to_Use_
+
 Volume_Fraction_
 
 Specific_Surface_Area_
 
-Definitions_
-
 Reference_
-
-How_to_Use_
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -23,60 +27,78 @@
 .. _Scattering_Invariant:
 
-Scattering Invariant
---------------------
+Scattering (Porod) Invariant
+----------------------------
 
-The scattering invariant (Q*) is a model-independent quantity that can be 
-easily calculated from scattering data.
+The scattering, or Porod, invariant (Q*\) is a model-independent quantity that 
+can be easily calculated from scattering data.
 
-For two phase systems, the scattering invariant, Q*, is defined as the 
-integral of the square of the wave transfer (q) multiplied by the scattering 
-cross section over the full range of q.
-
-Q* is given by the following equation
+For two phase systems, the scattering invariant is defined as the integral of 
+the square of the wave transfer (Q) multiplied by the scattering cross section 
+over the full range of Q from zero to infinity, that is
 
 .. image:: image001.gif
 
-This model independent quantity (Q*) is calculated from the scattering data 
-that can be used to determine the volume fraction and the specific area of the 
-sample under consideration.
+where *g = Q* for pinhole geometry (SAS) and *g = Qv* (the slit height) for  
+slit geometry (USAS).
 
-These quantities are useful in their own right and can be used in further 
-analysis. With this scattering invariant module users will also be able to 
-determine the consistency of those properties between data. There is no real 
-data defined from zero to infinity, there usually have limited range.
+The worth of Q*\  is that it can be used to determine the volume fraction and 
+the specific area of a sample. Whilst these quantities are useful in their own 
+right they can also be used in further analysis.
 
-Q* is not really computed from zero to infinity. Our maximum q range is 
-1e-5 ~ 10 (1/Angstrom). The lower and/or higher q range than data given can be 
-extrapolated by fitting some data nearby.
+The difficulty with using Q*\  arises from the fact that experimental data is 
+never measured over the range 0 =< *Q* =< infinity. At best, combining USAS and 
+WAS data might cover the range 1e-5 =< *Q* =< 10 1/\ |Ang| . Thus it is usually 
+necessary to extrapolate the experimental data to low and high *Q*. For this
 
-The scattering invariant is computed as follows
+High-*Q* region (>= *Qmax* in data)
 
-*I(q)* = *I(q)*  w/o background : If the data includes a background, user sets 
-the value to subtract the background for the Q* computation.
+*  The power law function *C*/*Q*\ :sup:`4` is used where the constant 
+   *C* (= 2.\ |pi|\ .(\ |bigdelta|\ |rho|\ ).\ *Sv*\ ) is to be found by fitting part of data 
+   within the range *Q*\ :sub:`N-m` to *Q*\ :sub:`N` (where m < N).
 
-Reset *I(q)* = *I(q)* scaling factor* , delta *I(q) =*  delta *I(q)*scaling 
-factor* : If non-zero scaling factor is given, it will be considered.
+Low-*Q* region (<= *Qmin* in data)
 
-Invariant
+*  The Guinier function *I0.exp(-Rg*\ :sup:`2`\ *Q*\ :sup:`2`\ */3)* where *I0* 
+   and *Rg* are obtained by fitting as for the high-*Q* region above. 
+   Alternatively a power law can be used.
 
-.. image:: image001.gif
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
 
-where *g =q*  for the pinhole geometry and *g =qv*  (the slit height) for the 
-slit geometry which can be given in data or as a value.
+.. _How_to_Use:
 
-Higher q-region (\>= qmax in data)
+How to Use
+----------
 
-Power law (w/o background term) function = C/q4will be used
+1) Select *Invariant* from the *Analysis* menu on the SasView toolbar.
 
-where the constant C(=2pi(delta(rho))Sv) is to be found by fitting part of 
-data with the range of qN-mto qN(m\<N).
+2) Load some data with the *Data Explorer*.
 
-Lower q-region (\<= qmin in data):
+3) Select a dataset and use the *Send To* button on the *Data Explorer* to load 
+   the dataset into the *Invariant* perspective.
 
-Guinier function = *I0exp(-Rg2q2/3)*  where I0and Rgare obtained by fitting,
+4) Use the *Customised Input* boxes on the *Invariant* perspective to subtract 
+   any background, specify the contrast (i.e. difference in SLDs - this must be 
+   specified for the eventual value of Q*\  to be on an absolute scale), or to 
+   rescale the data.
 
-similarly to the high q region above.
+5) Adjust the extrapolation range as necessary. In most cases the default 
+   values will suffice.
 
-Power law can also be used.
+6) Click the *Compute* button.
+
+7) To include a lower and/or higher Q range, check the relevant *Enable 
+   Extrapolate* check boxes.
+   
+   If power law extrapolations are chosen, the exponent can be either held 
+   fixed or fitted. The number of points, Npts, to be used for the basis of the 
+   extrapolation can also be specified.
+
+8) If the value of Q*\  calculated with the extrapolated regions is invalid, a 
+   red warning will appear at the top of the *Invariant* perspective panel.
+
+   The details of the calculation are available by clicking the *Details* 
+   button in the middle of the panel.
+
+.. image:: image005.gif
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -87,13 +109,11 @@
 ---------------
 
+The volume fraction |phi| is related to Q*\  by
+
 .. image:: image002.gif
 
-where delta(rho) is the SLD contrast of which value is given by users.
+where |bigdelta|\ |rho| is the SLD contrast.
 
 .. image:: image003.gif
-
-Thus
-
-where 0 =\< *A*  =\<1/4 in order for these values to be physically valid.
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -104,23 +124,9 @@
 ---------------------
 
+The specific surface area *Sv* is related to Q*\  by
+
 .. image:: image004.gif
 
-where *A*  and *Q**  are obtained from previous sections, and the Porod 
-constant *Cp*  is given by users.
-
-.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
-
-.. _Definitions:
-
-Definitions
------------
-
-Q: the magnitude of neutron (or X-ray) momentum transfer vector.
-
-I(Q): the scattering intensity as a function of the momentum transfer Q.
-
-Invariant total is the sum of the invariant calculated from datas q range and
-the invariant resulting from extrapolation at low q range and at high q range 
-if considered.
+where *Cp* is the Porod constant.
 
 .. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
@@ -131,42 +137,11 @@
 ----------
 
-Chapter 2 in O. Glatter and O. Kratky, "Small Angle X-Ray Scattering", Academic 
-Press, New York, 1982
+O. Glatter and O. Kratky
+Chapter 2 in *Small Angle X-Ray Scattering*
+Academic Press, New York, 1982
 
 http://physchem.kfunigraz.ac.at/sm/
 
-.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
+.. ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZ
 
-.. _How_to_Use:
-
-How to Use
-----------
-
-1. Loading data to the panel: Open the data file from File in the menu bar. 
-Select loaded data from a plot panel by highlighting that it until its color 
-turns yellow. Then right click on that the data and selects the option Compute 
-Invariant. The application automatically computes the invariant value if the 
-data loaded is valid.
-
-2. To subtract a background or/and to rescale the data, type the values in 
-Customized Input box.
-
-3. If you want to calculate the volume fraction and the specific surface 
-area, type the optional inputs in the customized input box, and then press 
-'Compute' button.
-
-4. The invariant can also be calculated including the outside of the data Q 
-range:  To include the lower Q and/or the higher Q range, check in the enable 
-extrapolation check box in 'Extrapolation' box. If the power low is chosen,
-the power (exponent) can be either held or fitted by checking the 
-corresponding radio button.  The Npts that is being used for the extrapolation 
-can be specified.
-
-5. If the invariant calculated from the extrapolated region is too large, it 
-will be warn in red at the top of the panel, which means that your data is not 
-proper to calculate the invariant.
-
-6. The details of the calculation is available by clicking the 'Details'
-button in the middle of the panel.
-
-.. image:: image005.gif
+.. note::  This help document was last changed by Steve King, 19Feb2015