Index: src/sas/qtgui/Perspectives/Corfunc/UI/CorfuncPanel.ui
===================================================================
--- src/sas/qtgui/Perspectives/Corfunc/UI/CorfuncPanel.ui	(revision 6930b91ff56befe2c8d86e3b38146b4ef37f524e)
+++ src/sas/qtgui/Perspectives/Corfunc/UI/CorfuncPanel.ui	(revision 728b29199330df1bcf1b96d2a29573afa15379b0)
@@ -44,10 +44,7 @@
           <layout class="QFormLayout" name="formLayout_2">
            <item row="0" column="0">
-            <widget class="QDoubleSpinBox" name="guinierA">
-             <property name="readOnly">
-              <bool>true</bool>
-             </property>
-             <property name="decimals">
-              <number>7</number>
+            <widget class="QLineEdit" name="guinierA">
+             <property name="readOnly">
+              <bool>true</bool>
              </property>
             </widget>
@@ -61,16 +58,7 @@
            </item>
            <item row="1" column="0">
-            <widget class="QDoubleSpinBox" name="guinierB">
-             <property name="readOnly">
-              <bool>true</bool>
-             </property>
-             <property name="decimals">
-              <number>7</number>
-             </property>
-             <property name="minimum">
-              <double>-1000000.000000000000000</double>
-             </property>
-             <property name="maximum">
-              <double>1000000.000000000000000</double>
+            <widget class="QLineEdit" name="guinierB">
+             <property name="readOnly">
+              <bool>true</bool>
              </property>
             </widget>
@@ -99,10 +87,7 @@
           <layout class="QFormLayout" name="formLayout_3">
            <item row="0" column="0">
-            <widget class="QDoubleSpinBox" name="porodK">
-             <property name="readOnly">
-              <bool>true</bool>
-             </property>
-             <property name="decimals">
-              <number>7</number>
+            <widget class="QLineEdit" name="porodK">
+             <property name="readOnly">
+              <bool>true</bool>
              </property>
             </widget>
@@ -116,10 +101,7 @@
            </item>
            <item row="1" column="0">
-            <widget class="QDoubleSpinBox" name="porodSigma">
-             <property name="readOnly">
-              <bool>true</bool>
-             </property>
-             <property name="decimals">
-              <number>7</number>
+            <widget class="QLineEdit" name="porodSigma">
+             <property name="readOnly">
+              <bool>true</bool>
              </property>
             </widget>
@@ -168,5 +150,5 @@
        </item>
        <item row="0" column="2">
-        <widget class="QDoubleSpinBox" name="avgIntThick"/>
+        <widget class="QLineEdit" name="avgIntThick"/>
        </item>
        <item row="0" column="3">
@@ -178,5 +160,5 @@
        </item>
        <item row="1" column="0">
-        <widget class="QDoubleSpinBox" name="avgHardBlock"/>
+        <widget class="QLineEdit" name="avgHardBlock"/>
        </item>
        <item row="1" column="1">
@@ -188,5 +170,5 @@
        </item>
        <item row="1" column="2">
-        <widget class="QDoubleSpinBox" name="avgCoreThick"/>
+        <widget class="QLineEdit" name="avgCoreThick"/>
        </item>
        <item row="1" column="3">
@@ -198,5 +180,5 @@
        </item>
        <item row="2" column="0">
-        <widget class="QDoubleSpinBox" name="polydisp"/>
+        <widget class="QLineEdit" name="polydisp"/>
        </item>
        <item row="2" column="1">
@@ -208,5 +190,5 @@
        </item>
        <item row="2" column="2">
-        <widget class="QDoubleSpinBox" name="localCrystal"/>
+        <widget class="QLineEdit" name="localCrystal"/>
        </item>
        <item row="2" column="3">
@@ -218,5 +200,5 @@
        </item>
        <item row="0" column="0">
-        <widget class="QDoubleSpinBox" name="longPeriod"/>
+        <widget class="QLineEdit" name="longPeriod"/>
        </item>
       </layout>
@@ -253,14 +235,8 @@
            </item>
            <item row="0" column="0">
-            <widget class="QDoubleSpinBox" name="qMin">
+            <widget class="QLineEdit" name="qMin">
              <property name="toolTip">
               <string>Values with q &lt; qmin will be used for Guinier back extrapolation</string>
              </property>
-             <property name="decimals">
-              <number>4</number>
-             </property>
-             <property name="singleStep">
-              <double>0.001000000000000</double>
-             </property>
             </widget>
            </item>
@@ -273,13 +249,7 @@
            </item>
            <item row="1" column="0">
-            <widget class="QDoubleSpinBox" name="qMax1">
+            <widget class="QLineEdit" name="qMax1">
              <property name="toolTip">
               <string>Values with Uppder &lt; q &lt; Cutoff will be used for Porod forward extrapolation</string>
-             </property>
-             <property name="decimals">
-              <number>4</number>
-             </property>
-             <property name="singleStep">
-              <double>0.001000000000000</double>
              </property>
             </widget>
@@ -316,23 +286,14 @@
            </item>
            <item row="1" column="2">
-            <widget class="QDoubleSpinBox" name="bg">
-             <property name="readOnly">
-              <bool>true</bool>
-             </property>
-             <property name="decimals">
-              <number>4</number>
+            <widget class="QLineEdit" name="bg">
+             <property name="readOnly">
+              <bool>true</bool>
              </property>
             </widget>
            </item>
            <item row="2" column="0">
-            <widget class="QDoubleSpinBox" name="qMax2">
+            <widget class="QLineEdit" name="qMax2">
              <property name="toolTip">
               <string>Values with Uppder &lt; q &lt; Cutoff will be used for Porod forward extrapolation</string>
-             </property>
-             <property name="decimals">
-              <number>4</number>
-             </property>
-             <property name="singleStep">
-              <double>0.001000000000000</double>
              </property>
             </widget>